#!/bin/sh

stdlib=LIBDIR

linkalso=true
includes=""
compopt=""
linkopt=""
custom=""
linkfiles=""
cc=gcc
ccfiles=""
cclib=""
ccopt=""
linkout=a.out

while : ; do
  case $1 in
    "")
      break;;
    *.sml)
      camlrunm $stdlib/mosmlcmp -stdlib $stdlib $includes $compopt $1 || exit $?
      linkfiles="$linkfiles $1";;
    *.sig)
      camlrunm $stdlib/mosmlcmp -stdlib $stdlib $includes $compopt $1 || exit $?
      ;;
    *.uo)
      linkfiles="$linkfiles $1";;
    -c)
      linkalso=false;;      
    -I|-include)
      includes="$includes -I $2"
      shift;;
    -P|-perv)
      compopt="$compopt -P $2"
      linkopt="$linkopt -P $2"
      shift;;
    -q|-quotation)
      compopt="$compopt $1";;
    -i)
      compopt="$compopt $1";;
    -g|-debug)
      compopt="$compopt $1"
      linkopt="$linkopt $1";;
    -noheader)
      linkopt="$linkopt $1";;
    -o|-exec)
      linkout=$2
      shift;;
    -stdlib)
      stdlib=$2
      shift;;
    -v|-version)
      echo "The Moscow ML system, version 1.31"
      echo "  (standard library from $stdlib)"
      camlrunm -V
      camlrunm $stdlib/mosmlcmp -version
      camlrunm $stdlib/mosmllnk -version;;
    -files)
      linkfiles="$linkfiles $1 $2"
      shift;;
    -*)
      echo "Unknown option \"$1\", ignored" >&2;;
    *)
      echo "I don't know what to do with file \"$1\", ignored" >&2;;
  esac
  shift
done

if $linkalso && test -n "$linkfiles"; then
  camlrunm $stdlib/mosmllnk -stdlib $stdlib $includes $custom $linkopt \
    -exec $linkout $linkfiles || exit $?
fi

exit 0
